﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Text;
using DomainClasses;

namespace DataAccessLayer
{
    public class AirlineContext:DbContext
    {
        public DbSet<Airline> Airlines { get; set; }
        public DbSet<FlightLeg> Legs { get; set; }
        public DbSet<Passenger> Passengers { get; set; }
        public DbSet<ScheduledFlight> Flights { get; set; }
     

        public override int SaveChanges()
        {
            foreach (var entry in this.ChangeTracker.Entries()
                .Where(e=>e.Entity is ILogInfo &&
                    ((e.State==EntityState.Added)  ||(e.State==EntityState.Modified))))
            {
                ((ILogInfo)entry.Entity).ModifiedDate = DateTime.Today;
            }
            return base.SaveChanges();
        }
    }
}
