﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web;
using System.Web.Http;
using System.Web.Http.OData;
using DomainClasses;
using DataAccessLayer;

namespace MvcApplication1.Controllers
{
    //note that this is code generated 
    //directly from the MVC scaffolding and
    //I have not edited it 
    public class AirlineController : ApiController
    {
        private AirlineContext db = new AirlineContext();

        // GET api/Default1
        public IEnumerable<Airline> GetAirlines()
        {
            return db.Airlines.AsEnumerable();
        }

        // GET api/Default1/5
        public Airline GetAirline(int id)
        {
            Airline airline = db.Airlines.Find(id);
            if (airline == null)
            {
                throw new HttpResponseException(Request.CreateResponse(HttpStatusCode.NotFound));
            }

            return airline;
        }

        // PUT api/Default1/5
        public HttpResponseMessage PutAirline(int id, Airline airline)
        {
            if (!ModelState.IsValid)
            {
                return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState);
            }

            if (id != airline.Id)
            {
                return Request.CreateResponse(HttpStatusCode.BadRequest);
            }

            db.Entry(airline).State = EntityState.Modified;

            try
            {
                db.SaveChanges();
            }
            catch (DbUpdateConcurrencyException ex)
            {
                return Request.CreateErrorResponse(HttpStatusCode.NotFound, ex);
            }

            return Request.CreateResponse(HttpStatusCode.OK);
        }

        // POST api/Default1
        public HttpResponseMessage PostAirline(Airline airline)
        {
            if (ModelState.IsValid)
            {
                db.Airlines.Add(airline);
                db.SaveChanges();

                HttpResponseMessage response = Request.CreateResponse(HttpStatusCode.Created, airline);
                response.Headers.Location = new Uri(Url.Link("DefaultApi", new { id = airline.Id }));
                return response;
            }
            else
            {
                return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState);
            }
        }

        // DELETE api/Default1/5
        public HttpResponseMessage DeleteAirline(int id)
        {
            Airline airline = db.Airlines.Find(id);
            if (airline == null)
            {
                return Request.CreateResponse(HttpStatusCode.NotFound);
            }

            db.Airlines.Remove(airline);

            try
            {
                db.SaveChanges();
            }
            catch (DbUpdateConcurrencyException ex)
            {
                return Request.CreateErrorResponse(HttpStatusCode.NotFound, ex);
            }

            return Request.CreateResponse(HttpStatusCode.OK, airline);
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}